#coding:utf-8
import binascii
import json
import random
import socket
import threading
import time

from lib.Mnew.DataUpstreamTransport_msg import DataUpstreamTransport_msg
from lib.Mnew.Location_msg import Location_msg
from lib.Mnew.TerminalHeartbeat_msg import TerminalHeartbeat_msg
from lib.Mnew.TerminalRegister_msg import TerminalRegister_msg
from lib.Mnew.TerminalVersionInfo_msg import TerminalVersionInfo_msg
from lib.pressure.ThreadBase import ThreadBase

class SendMultMsgNewThread(ThreadBase):
    def __init__(self,host="10.100.11.20",port=9001,msg=""):
        self.host = host
        self.port = port
        self.msg = msg
        self.timeOut = 30                           #socket超时时间
        self.BUF_SIZE = 1024                       #接收消息缓存
        self.threadCount = 10                      #并发线程数
        self.totalTime = 0                         #所有线程的运行总和
        self.threadArr = {}                        #保存每个线程的信息
        self.failThreadCount = 0                   #失败线程数
        self.durThreads = []                        #持续发送线程数组，当数组为空，表示所有线程已经结束
        dt = 1 * 1 * 60
        self.durTime = dt                          #线程持续时间
        self.connectTimeoutNum = 0                 #连接超时线程数
        self.sendTimeoutNum = 0                       #发送超时线程数
        self.reviceTimeoutNum = 0                     #接收超时线程数
        self.sucessNum = 0                            #成功线程数
        self.setStartCarNumber = 0                    #开始车机号
        self.messageCon = []                          #用来统计每个线程所发的消息数
        self.messageCons = 0                          # 用来统计每个线程所发的消息数
        pass

    ############################################
    # 设置host
    ############################################
    def setHost(self,host):
        self.host = host
    ############################################
    # 设置端口号
    ############################################
    def setPort(self,port):
        self.port = port
    ############################################
    # 设置消息
    ############################################
    def setMsg(self,msg):
        self.msg = msg
    ############################################
    # 设置并发线程数
    ############################################
    def setThreadCount(self,threadCount):
        self.threadCount = threadCount
    ############################################
    # 设置持续时间
    ############################################
    def setDurTime(self,durTime):
        self.durTime = durTime
    ############################################
    # 设置超时时间
    ############################################
    def setTimeOut(self,timeOut):
        self.timeOut = timeOut
    ############################################
    # 设置开始车机号
    ############################################
    def setSetStartCarNumber(self,setStartCarNumber):
        self.setStartCarNumber = setStartCarNumber

    ############################################
    # 发送一条消息
    ############################################
    def sendMsg(self,msg,threadName):
        msg = msg
        client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        client.setsockopt(socket.SOL_SOCKET, socket.SO_KEEPALIVE, 1)  # 在客户端开启心跳
        client.settimeout(self.timeOut)
        startTime = int(time.time() * 1000)
        try:
            client.connect((self.host, self.port))
            client.send(binascii.a2b_hex(msg))
        except BaseException as e:
            client.close()
            self.threadArr[threadName]["status"] = 1
            self.failThreadCount = self.failThreadCount + 1
            print("连接超时，socket断开")
            return
        try:
            data = client.recv(self.BUF_SIZE)
            # print(data)
        except BaseException as e:
            # traceback.print_exc()
            client.close()
            # raise RuntimeError('socket 接收消息超时！')
            self.threadArr[threadName]["status"] = 1
            self.failThreadCount = self.failThreadCount + 1
            print('socket 接收消息超时！')
            return
        endTime = int(time.time() * 1000)
        timeExpend = endTime - startTime
        self.threadArr[threadName]["timeExp"] = timeExpend
        self.totalTime = self.totalTime + timeExpend
        client.close()

    ############################################
    # 持续发送消息
    # dur: 持续发送时间，如果为0一直发送， 设置了事件为持续发送多少秒，默认为一分钟
    ############################################
    def sendMsgContinuous(self,carId,threadName="thread0"):
        client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        client.setsockopt(socket.SOL_SOCKET, socket.SO_KEEPALIVE, 1)  # 在客户端开启心跳
        client.settimeout(self.timeOut)
        startTime = int(time.time())
        endTime = int(time.time())
        msgCon = 0                                    #统计线程发的消息数量
        self.durThreads.append(threadName)
        try:
            client.connect((self.host, self.port))
        except BaseException as e:
            client.close()
            self.durThreads.remove(threadName)
            self.threadArr[threadName]["status"] = 1
            self.failThreadCount = self.failThreadCount + 1
            endTime = int(time.time())
            timeExpend = endTime - startTime
            self.threadArr[threadName]["timeExp"] = timeExpend
            self.connectTimeoutNum = self.connectTimeoutNum + 1
            self.messageCon.append(msgCon)
            self.threadArr[threadName]["msgCon"] = msgCon
            print(threadName + ":" + "连接超时，socket断开")
            return
        while (endTime - startTime) < self.durTime:
            msg = self.getRandomMsg_new(carId)
            try:
                client.send(binascii.a2b_hex(msg))
                msgCon = msgCon + 1
                self.messageCons = self.messageCons + 1
            except BaseException as e:
                client.close()
                self.durThreads.remove(threadName)
                self.threadArr[threadName]["status"] = 1
                self.failThreadCount = self.failThreadCount + 1
                endTime = int(time.time())
                timeExpend = endTime - startTime
                self.threadArr[threadName]["timeExp"] = timeExpend
                self.sendTimeoutNum = self.sendTimeoutNum + 1
                self.messageCon.append(msgCon)
                self.threadArr[threadName]["msgCon"] = msgCon
                print(threadName + ":" + "发送超时，socket断开")
                return
            try:
                data = client.recv(self.BUF_SIZE)
            except BaseException as e:
                client.close()
                self.durThreads.remove(threadName)
                self.threadArr[threadName]["status"] = 1
                self.failThreadCount = self.failThreadCount + 1
                self.reviceTimeoutNum = self.reviceTimeoutNum + 1
                self.messageCon.append(msgCon)
                self.threadArr[threadName]["msgCon"] = msgCon
                print(threadName + ":" + 'socket 接收消息超时！')
                endTime = int(time.time())
                timeExpend = endTime - startTime
                self.threadArr[threadName]["timeExp"] = timeExpend
                return
            endTime = int(time.time())
            sleepTime = random.randint(1, 5)
            time.sleep(sleepTime)
        endTime = int(time.time())
        timeExpend = endTime - startTime
        self.threadArr[threadName]["timeExp"] = timeExpend
        self.messageCon.append(msgCon)
        self.threadArr[threadName]["msgCon"] = msgCon
        client.close()
        self.sucessNum = self.sucessNum + 1
        self.durThreads.remove(threadName)

    ############################################
    # 启动并发线程
    ############################################
    def startThread(self):
        timeStart = int(time.time() * 1000)
        for i in range(0,self.threadCount):
            threadName = "thread-" + str(i)
            theThread = threading.Thread(target=self.sendMsg, args=("7e0002000001314620111800065b7e",threadName,))  # 数据写死，心跳
            threadInfo = {}
            threadInfo["name"] = threadName
            threadInfo["status"] = 0
            self.threadArr[threadName] = threadInfo
            theThread.start()
        timeEnd = int(time.time() * 1000)
        timeExpend = timeEnd - timeStart
        if timeExpend == 0:
            timeExpend = 1000
        time.sleep(3)
        print("耗时：" + str(timeExpend) + " 毫秒")
        print("并发数据每秒发送：" + str(int(self.threadCount / (timeExpend / 1000))))
        print("平均响应时间：" + str(self.totalTime / self.threadCount) + "毫秒")
        print("发送总数：" + str(self.threadCount))
        print("响应失败数：" + str(self.failThreadCount))
        self.writeToFile("./data/threadDetails.json",self.threadArr)

    ############################################
    # 启动持续并发线程
    ############################################
    def startThreadContinuous(self):
        timeStart = int(time.time() * 1000)
        for i in range(0,self.threadCount):
            threadName = "thread-" + str(i)
            carid = 201912000000 + i + self.setStartCarNumber
            print(threadName + " 车机号：" + str(carid))
            theThread = threading.Thread(target=self.sendMsgContinuous, args=(carid,threadName,))  # 数据写死，心跳
            threadInfo = {}
            threadInfo["name"] = threadName
            threadInfo["status"] = 0
            self.threadArr[threadName] = threadInfo
            theThread.start()
        timeEnd = int(time.time() * 1000)
        timeExpend = timeEnd - timeStart
        print("耗时：" + str(timeExpend) + " 毫秒产生了" + str(self.threadCount) + "线程")
        time.sleep(0.5)     #防止启动的时候溜掉某些启动比较慢的线程
        tmp = 1
        while len(self.durThreads) != 0:
            print("剩余线程数_" + str(tmp) + "：" + str(len(self.durThreads)))
            tmp = tmp + 1
            timeArray = time.localtime(timeStart / 1000)
            testStart = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
            timeCur = int(time.time() * 1000)
            timeArray = time.localtime(timeCur / 1000)
            testCur = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
            info_0 = "-------------------------- 统计信息（pre） --------------------------"
            info_1 = "耗时：" + str(timeExpend) + " 毫秒产生了" + str(self.threadCount) + "线程"
            info_2 = "开始测试时间：" + testStart
            info_4 = "设置socket超时时间：" + str(self.timeOut)
            info_5 = "设置线程持续时间：" + str(self.durTime)
            info_6 = "剩余线程数：" + str(len(self.durThreads))
            info_8 = "连接失败：" + str(self.connectTimeoutNum)
            info_9 = "发送失败：" + str(self.sendTimeoutNum)
            info_10 = "接收失败：" + str(self.reviceTimeoutNum)
            info_11 = "当前写入时间：" + testCur
            info_12 = "当前发送消息总数：" + str(self.messageCons)
            result = info_0 + "\n" + info_1 + "\n" + info_2 + "\n" + info_4 + "\n" + info_5 + "\n" + info_6 + "\n"
            result = result + info_8 + "\n" + info_9 + "\n" + info_10 + "\n" + info_11 + "\n" + info_12 + "\n"
            self.writeToFile("./result_pre.txt",result)
            time.sleep(5)
        timeArray = time.localtime(timeStart / 1000)
        testStart = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        timeEnd = int(time.time() * 1000)
        timeArray = time.localtime(timeEnd / 1000)
        testestEnd = time.strftime("%Y-%m-%d %H:%M:%S", timeArray)
        time.sleep(2)      #防止线程慢的时候，某些线程被漏统计的情况
        info_0 = "-------------------------- 统计信息 --------------------------"
        print(info_0)
        totalMsg = 0
        for i in self.messageCon:
            totalMsg = totalMsg + i
        info_1 = "耗时：" + str(timeExpend) + " 毫秒产生了" + str(self.threadCount) + "线程"
        info_2 = "开始测试时间：" + testStart
        info_3 = "结束测试时间：" + testestEnd
        info_4 = "设置socket超时时间：" + str(self.timeOut)
        info_5 = "设置线程持续时间：" + str(self.durTime)
        info_6 = "成功线程数：" + str(self.sucessNum)
        info_7 = "消息总数：" + str(totalMsg)
        info_8 = "连接失败：" + str(self.connectTimeoutNum)
        info_9 = "发送失败：" + str(self.sendTimeoutNum)
        info_10 = "接收失败：" + str(self.reviceTimeoutNum)
        print(info_1)
        print(info_2)
        print(info_3)
        print(info_4)
        print(info_5)
        print(info_6)
        print(info_7)
        print(info_8)
        print(info_9)
        print(info_10)
        self.writeToFile("./threadDetailsContinuous.json",json.dumps(self.threadArr))
        info_11 = self.getInfoFromResult("./threadDetailsContinuous.json")
        result = info_0 + "\n" + info_1 + "\n" + info_2 + "\n" + info_3 + "\n" + info_4 + "\n" + info_5 + "\n" + info_6 + "\n"
        result = result + info_7 + "\n" + info_8 + "\n" + info_9 + "\n" + info_10 + "\n" + info_11
        self.writeToFile("./result.txt", result)

    def writeToFile(self,path,data):
        with open(path, "w", encoding='utf-8') as fi:
            #json.dump(data, fi)
            fi.write(data)

    # 获取随机消息数据(新硬件车机)
    def getRandomMsg_new(self, carId):
        # carId = 201912010002
        wh = random.randint(0,4)
        msg = ""
        if wh == 0:
            hearbeatObj = TerminalHeartbeat_msg()
            hearbeatObj.setPhoneNum(carId)
            hearbeat_msg = hearbeatObj.generateMsg()
            msg = hearbeat_msg
        elif wh == 1:
            registerObj = TerminalRegister_msg()
            register_msg = registerObj.generateMsg()
            msg = register_msg
        elif wh == 2:
            versionInfoObj = TerminalVersionInfo_msg()
            versionInfo_msg = versionInfoObj.generateMsg()
            msg = versionInfo_msg
        elif wh == 3:
            dataUpstreamObj = DataUpstreamTransport_msg()
            dataUpstream_msg = dataUpstreamObj.generateMsg()
            msg = dataUpstream_msg
        elif wh == 4:
            locationObj = Location_msg()
            location_msg = locationObj.generateMsg()
            msg = location_msg
        return msg


    def getInfoFromResult(self,path):
        with open(path, "r", encoding='utf-8') as fi:
            d = fi.read()
            d = json.loads(d)
            msgC = 0
            failT = 0
            for i in d:
                msgC = msgC + d[i]["msgCon"]
                if d[i]["status"] == 1:
                    failT = failT +1
            info_1 = "文件统计总消息数：" + str(msgC)
            info_2 = "文件统计总失败数：" + str(failT)
            print(info_1)
            print(info_2)
            return info_1 + "\n" +info_2 + "\n"


if __name__ == "__main__":
    t = SendMultMsgNewThread()
    t.setHost("10.100.11.20")
    t.setPort(9001)
    t.startThreadContinuous()

















